/* Generated by GOB (v2.0.15)   (do not edit directly) */



/*
 * Copyright © 2009  Red Hat, Inc. All rights reserved.
 * Copyright © 2009  Ding-Yi Chen <dchen at redhat.com>
 *
 * This file is part of the ibus-chewing Project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */ 
#include <stdlib.h>
#include <libintl.h>
#include <ibus.h>
#include <chewing.h>
#include <string.h>
#include <stdio.h>
#define GETTEXT_PACKAGE "gtk20"
#include <glib/gi18n.h>
#include <gconf/gconf.h>
#include <gconf/gconf-client.h>
#include <X11/extensions/XTest.h>
#include <X11/Xlib.h>


#include <glib.h>
#include <glib-object.h>


#define GCONF_KEY_PREFIX "/desktop/ibus/engine/Chewing/"
extern gboolean ibus_chewing_verbose;

#ifndef __IBUS_CHEWING_ENGINE_H__
#define __IBUS_CHEWING_ENGINE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef enum {
	CHEWING_KBTYPE_INVALID = -1,
	CHEWING_KBTYPE_DEFAULT,
	CHEWING_KBTYPE_HSU,
	CHEWING_KBTYPE_IBM,
	CHEWING_KBTYPE_GIN_YIEH,
	CHEWING_KBTYPE_ETEN,
	CHEWING_KBTYPE_ETEN26,
	CHEWING_KBTYPE_DVORAK,
	CHEWING_KBTYPE_DVORAK_HSU,
	CHEWING_KBTYPE_DACHEN_CP26,
	CHEWING_KBTYPE_HAN_YU
} ChewingKbType;
#define CHEWING_TYPE_KBTYPE chewing_kbtype_get_type()
GType chewing_kbtype_get_type (void);


typedef enum {
	CHEWING_MODIFIER_SYNC_NONE,
	CHEWING_MODIFIER_SYNC_FROM_KEYBOARD,
	CHEWING_MODIFIER_SYNC_FROM_IM
} ChewingModifierSync;
#define CHEWING_TYPE_MODIFIER_SYNC chewing_modifier_sync_get_type()
GType chewing_modifier_sync_get_type (void);


/*
 * Type checking and casting macros
 */
#define IBUS_TYPE_CHEWING_ENGINE	(ibus_chewing_engine_get_type())
#define IBUS_CHEWING_ENGINE(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), ibus_chewing_engine_get_type(), IBusChewingEngine)
#define IBUS_CHEWING_ENGINE_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), ibus_chewing_engine_get_type(), IBusChewingEngine const)
#define IBUS_CHEWING_ENGINE_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), ibus_chewing_engine_get_type(), IBusChewingEngineClass)
#define IBUS_IS_CHEWING_ENGINE(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), ibus_chewing_engine_get_type ())

#define IBUS_CHEWING_ENGINE_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), ibus_chewing_engine_get_type(), IBusChewingEngineClass)

/* Private structure type */
typedef struct _IBusChewingEnginePrivate IBusChewingEnginePrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_IBUS_CHEWING_ENGINE__
#define __TYPEDEF_IBUS_CHEWING_ENGINE__
typedef struct _IBusChewingEngine IBusChewingEngine;
#endif
struct _IBusChewingEngine {
	IBusEngine __parent__;
	/*< public >*/
	ChewingContext * context;
	ChewingModifierSync sync_CapsLock_local;
	IBusProperty * chieng_prop;
	IBusProperty * alnumSize_prop;
	IBusProperty * settings_prop;
	IBusProperty * kbType_prop;
	IBusProperty * selKeys_prop;
	GPtrArray * miscOption_array;
	IBusPropList * prop_list;
	IBusConfig * config;
	/*< private >*/
	gint selKeys[MAX_SELKEY]; /* protected */
	IBusLookupTable * table; /* protected */
	IBusPropList * kbType_prop_subList; /* protected */
	IBusPropList * selKeys_prop_subList; /* protected */
	IBusChewingEnginePrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _IBusChewingEngineClass IBusChewingEngineClass;
struct _IBusChewingEngineClass {
	IBusEngineClass __parent__;
	GConfClient * gConfClient;
	IBusText * chieng_prop_label_chi;
	IBusText * chieng_prop_label_eng;
	IBusText * alnumSize_prop_label_full;
	IBusText * alnumSize_prop_label_half;
	IBusText * settings_prop_label;
	IBusText * kbType_prop_label;
	IBusText * selKeys_prop_label;
	IBusText ** kbType_prop_labels;
	IBusText ** selKeys_prop_labels;
};


/*
 * Public methods
 */
GType	ibus_chewing_engine_get_type	(void);
void 	ibus_chewing_engine_refresh_property_list	(IBusChewingEngine * self);
gboolean 	ibus_chewing_engine_save_config	(IBusChewingEngine * self,
					const gchar * key_suffix,
					gpointer configValue);
gboolean 	ibus_chewing_engine_save_kbType	(IBusChewingEngine * self,
					ChewingKbType kbType);
gint 	ibus_chewing_engine_get_selKeys_index	(IBusChewingEngine * self);
void 	ibus_chewing_engine_set_selKeys_string	(IBusChewingEngine * self,
					const gchar * selKeys_str);
gboolean 	ibus_chewing_engine_save_selKeys_string	(IBusChewingEngine * self,
					const gchar * selKeys_str);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
